import { Action } from '@reactive-redux/store';
import { Edge, Node } from './models';
export declare enum GraphActions {
    ADD_NODE = "[Graph] Add node",
    ADD_EDGE = "[Graph] Add edge",
    REMOVE_NODE = "[Graph] Remove node",
    REMOVE_EDGE = "[Graph] Remove edge"
}
export declare class AddNode implements Action {
    payload: Node;
    readonly type: GraphActions;
    constructor(payload: Node);
}
export declare class AddEdge implements Action {
    payload: Edge;
    readonly type: GraphActions;
    constructor(payload: Edge);
}
export declare class RemoveNode implements Action {
    payload: {
        key: string;
    };
    readonly type: GraphActions;
    constructor(payload: {
        key: string;
    });
}
export declare class RemoveEdge implements Action {
    payload: {
        from: string;
        to: string;
    };
    readonly type: GraphActions;
    constructor(payload: {
        from: string;
        to: string;
    });
}
