import { Store } from '@reactive-redux/store';
import { IGraph } from './reducers';
import { Node, Edge } from './models';
import { Observable } from 'rxjs';
export declare class Graph extends Store<IGraph> {
    private _initialValue;
    static readonly initialBlank: IGraph;
    state$: Observable<IGraph>;
    nodeCount$: Observable<number>;
    edgeCount$: Observable<number>;
    keys$: Observable<string[]>;
    values$: Observable<{
        value?: any;
        edges?: {
            [key: string]: {
                weight: number;
                name: string;
            };
        };
        key: string;
    }[]>;
    constructor(_initialValue?: IGraph);
    addNode(node: Node): void;
    removeNode(key: string): void;
    addEdge(edge: Edge): void;
    removeEdge(from: string, to: string): void;
    getValue$(key: string): Observable<any>;
    getEdges$(key: string): Observable<{
        weight: number;
        name: string;
        target: string;
    }[]>;
    isConnected$(keyA: string, keyB: string): Observable<boolean>;
}
