"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var store_1 = require("@reactive-redux/store");
var reducers_1 = require("./reducers");
var actions_1 = require("./actions");
var operators_1 = require("rxjs/operators");
var Graph = /** @class */ (function (_super) {
    __extends(Graph, _super);
    function Graph(_initialValue) {
        if (_initialValue === void 0) { _initialValue = Graph.initialBlank; }
        var _this = _super.call(this, _initialValue, reducers_1.reducerMap) || this;
        _this._initialValue = _initialValue;
        _this.nodeCount$ = _this.state$.pipe(store_1.select(function (state) { return state.nOfNodes; }));
        _this.edgeCount$ = _this.state$.pipe(store_1.select(function (state) { return state.nOfEdges; }));
        _this.keys$ = _this.state$.pipe(store_1.select(function (state) { return Object.keys(state.nodes); }));
        _this.values$ = _this.state$.pipe(store_1.select(function (state) { return Object.keys(state.nodes).map(function (key) { return (__assign({ key: key }, state.nodes[key])); }); }));
        return _this;
    }
    Graph.prototype.addNode = function (node) {
        this.dispatch(new actions_1.AddNode(node));
    };
    Graph.prototype.removeNode = function (key) {
        this.dispatch(new actions_1.RemoveNode({ key: key }));
    };
    Graph.prototype.addEdge = function (edge) {
        this.dispatch(new actions_1.AddEdge(edge));
    };
    Graph.prototype.removeEdge = function (from, to) {
        this.dispatch(new actions_1.RemoveEdge({ from: from, to: to }));
    };
    Graph.prototype.getValue$ = function (key) {
        return this.state$.pipe(store_1.select(function (state) { return state.nodes[key]; }), operators_1.map(function (e) { return (e ? e.value : undefined); }));
    };
    Graph.prototype.getEdges$ = function (key) {
        return this.state$.pipe(store_1.select(function (state) { return state.nodes[key]; }), operators_1.map(function (e) {
            return e && e.edges ? Object.keys(e.edges).map(function (target) { return (__assign({ target: target }, e.edges[target])); }) : [];
        }));
    };
    Graph.prototype.isConnected$ = function (keyA, keyB) {
        return this.state$.pipe(store_1.select(function (state) { return state.nodes[keyA]; }), operators_1.map(function (n) { return !!n.edges[keyB]; }));
    };
    Graph.initialBlank = {
        nodes: {},
        nOfNodes: 0,
        nOfEdges: 0
    };
    return Graph;
}(store_1.Store));
exports.Graph = Graph;
