import { Action } from '@reactive-redux/store';
import { Edge, Node } from './models';

export enum GraphActions {
  ADD_NODE = '[Graph] Add node',
  ADD_EDGE = '[Graph] Add edge',
  REMOVE_NODE = '[Graph] Remove node',
  REMOVE_EDGE = '[Graph] Remove edge'
}

export class AddNode implements Action {
  readonly type = GraphActions.ADD_NODE;

  constructor(public payload: Node) {}
}

export class AddEdge implements Action {
  readonly type = GraphActions.ADD_EDGE;

  constructor(public payload: Edge) {}
}

export class RemoveNode implements Action {
  readonly type = GraphActions.REMOVE_NODE;

  constructor(public payload: { key: string }) {}
}

export class RemoveEdge implements Action {
  readonly type = GraphActions.REMOVE_EDGE;

  constructor(public payload: { from: string; to: string }) {}
}
